'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _blockAlignment = require('./decorators/block-alignment');

var _blockAlignment2 = _interopRequireDefault(_blockAlignment);

var _style = {
  "centerWrapper": "draftJsEmojiPlugin__centerWrapper__l1cWY",
  "center": "draftJsEmojiPlugin__center__2hzUI",
  "left": "draftJsEmojiPlugin__left__23qnn",
  "right": "draftJsEmojiPlugin__right__1o-p7"
};

var _style2 = _interopRequireDefault(_style);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var defaultTheme = _extends({}, _style2.default);

// Block-Types to be handled will be stored here
var types = [];

var alignmentPlugin = function alignmentPlugin(config) {
  types = config.types || [];
  var theme = config.theme ? config.theme : defaultTheme;
  return {
    blockRendererFn: function blockRendererFn(contentBlock, _ref) {
      var setEditorState = _ref.setEditorState;
      var getEditorState = _ref.getEditorState;

      // Check if the contentBlock's block-type is registered to be handled
      if (types.indexOf(contentBlock.get('type')) !== -1) {
        return {
          // Wrap the contentBlock in the alignment decorator, that will either
          // handle the alignment with the above styles or let the wrapped
          // block handle itself if it defines
          decorators: [(0, _blockAlignment2.default)(setEditorState, getEditorState, theme)]
        };
      }return undefined;
    }
  };
};

exports.default = alignmentPlugin;